import { Messages } from '@enums/messages.enum';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable, OnDestroy } from '@angular/core';
import { share } from 'rxjs/operators';
import { environment } from '@env';
import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import jwt_decode from 'jwt-decode';
import { UiService } from '@services/ui.service';
import { SubSink } from 'subsink';

const API_URL = environment.apiUrl;

const httpOptions = {
    headers: new HttpHeaders({
        'Content-Type': 'application/json'
    }),
    withCredentials: true
};

@Injectable({
    providedIn: 'root'
})
export class SessionService implements OnDestroy {
    expired = false;

    /**
     * Variable contains all subscriptions
     * @private
     */
    private subs = new SubSink();

    private session: any = localStorage.getItem('user')
        ? JSON.parse(localStorage.getItem('user'))
        : null;

    constructor(
        public http: HttpClient,
        public router: Router,
        private ui: UiService
    ) {}

    /**
     * Executed method when view is destroyed
     */
    ngOnDestroy(): void {
        if (this.subs) {
            this.subs.unsubscribe();
        }
    }

    /**
     * Method to decode JWT Token and get expiration date
     */
    getTokenExpirationDate(): Date {
        const decoded: any = jwt_decode(this.session?.token);

        if (decoded.exp === undefined) {
            return null;
        }

        const date = new Date(0);
        date.setUTCSeconds(decoded.exp);

        return date;
    }

    /**
     * Method to verify if token already expired
     */
    isExpired(): boolean {
        if (!this.session) {
            return true;
        }

        const date = this.getTokenExpirationDate();
        if (date === undefined) {
            return false;
        }

        return !(date.valueOf() > new Date().valueOf());
    }

    /**
     * Method to get values from session variable
     * Local storage is set on login method
     */
    me() {
        return this.session;
    }

    /**
     * Method to clear local storage and redirect to login
     */
    clearSession() {
        const message = !this.isExpired()
            ? Messages.SuccessLogout
            : Messages.SessionExpired;

        this.expired = true;
        this.session = null;

        localStorage.removeItem('user');

        this.router
            .navigateByUrl('/')
            .then(() => this.ui.showSnackBar(message));
    }

    /**
     * Communicate with API method to reset password
     * @param email Email Password
     * @param password User Password
     */
    login(email: string, password: string) {
        const request = this.http
            .post(
                `${API_URL}/user/login`,
                {
                    email,
                    password
                },
                httpOptions
            )
            .pipe(share());

        this.subs.sink = request.subscribe((user) => {
            this.session = user;
            localStorage.setItem('user', JSON.stringify(user));
        });

        return request;
    }

    /**
     * Communicate with API method to reset password
     * @param email Email of user to reset password
     */
    reset(email: string) {
        return this.http
            .post(
                `${API_URL}/user/forgot-password`,
                { email, origin: `${environment.frontUrl}/change-password` },
                httpOptions
            )
            .pipe(share());
    }

    /**
     * Communicate with API method to change password
     * @param password New Password
     * @param confirmPassword Confirmation of New Password
     * @param token Token generated by Reset Password method
     */
    change(
        password: string,
        confirmPassword: string,
        token: string
    ): Observable<any> {
        return this.http
            .post(
                `${API_URL}/user/reset-password`,
                {
                    token,
                    password,
                    confirmPassword
                },
                httpOptions
            )
            .pipe(share());
    }
}
